#define LOG_SIZE 10000
#define MAX_LOG_ENTRIES 20

#define MIN_MSG_LENGTH 50

#define ACCEPT 1
#define REJECT 0

#define SEND 1
#define RECEIVE 0

#define YES 1
#define NO 0
#define UNDEFINED -1

typedef enum ContentType{
	change_cipher_spec = 	(unsigned char)0x14,
	alert = 				(unsigned char)0x15,
	handshake = 			(unsigned char)0x16,
	application_data = 		(unsigned char)0x17
} ContentType;

enum Msg_type{
	hello_request = 		(unsigned char)0x00,
	C_Hello = 				(unsigned char)0x01,
	S_Hello = 				(unsigned char)0x02,
	certificate = 			(unsigned char)11,
	S_KE = 					(unsigned char)12,
	S_CReq = 				(unsigned char)13,
	S_HD = 					(unsigned char)14,
	C_KE = 					(unsigned char)16,
	C_CV = 					(unsigned char)15,
	finished = 				(unsigned char)20,
	S_Cert,
	C_Cert,
	S_CCS,
	S_Fin,
	C_CCS,
	C_Fin,
	ServerNewSessionTicket = (unsigned char)0x04,
	UNDEFINED_TYPE
};
typedef enum Msg_type Msg_type;

enum Role{
	UNDEFINED_ROLE,
	SERVER,
	CLIENT
};
typedef enum Role Role;

enum PV{
	UNDEFINED_PV,
	SSL3,
	TLS1,
	TLS1_1,
	TLS1_2,
	TICKETS,
	ALPN,
	DTLS
};
typedef enum PV PV;

enum KEM{
	UNDEFINED_KEM,
	Anon,
	DiffieHellman,
	DHE,
	DHEExport,
	DHanon,
	ECDH,
	ECDHE,
	ECDHanon,
	CS_RSA,
	RSAExport,
	PSK
};
typedef enum KEM KEM;

enum Auth{
	UNDEFINED_AUTH,
	AUTH_REQUESTED,
	NO_AUTH,
	AUTH_NOT_PROVIDED,
	AUTH_PROVIDED,
	AUTH_WITH_FIXED_DH
};
typedef enum Auth Auth;

enum ID{
	DEFINED_ID,
	UNDEFINED_ID
};
typedef enum ID ID;

typedef struct state_mon {
	int version;
	int role;
	int kem;
	int last_message;

	unsigned char *log;
	unsigned int log_length;

	int client_auth;
	int resumption;
	int renegotiation;
	int ntick;

	int state_mon_initialized;
} STATE_MON;

