/*@ axiomatic Constants{
  	logic integer INT32_MAX = 2147483648;
	logic integer LOG_SIZE = 10000;
	logic integer MAX_LOG_ENTRIES = 20;
	logic integer MAX_CS_LIST_SIZE = 20;
	logic integer MIN_MSG_LENGTH = 50;
	logic integer ACCEPT = 1;
 	logic integer REJECT = 0;
 	logic integer SEND = 1;
 	logic integer RECEIVE = 0;
 	logic integer YES = 1;
 	logic integer NO = 0;
 	logic integer UNDEFINED = -1;
}
 */

/*@
 axiomatic MemCmp_uchar {
 logic integer memcmp_uchar{L}(unsigned char *s1, unsigned char *s2, ℤ n)
 reads s1[0..n - 1], s2[0..n - 1];

 axiom memcmp_zero_uchar{L}:
 \forall unsigned char *s1, *s2; \forall integer n;
 memcmp_uchar(s1,s2,n) == 0
 <==> \forall integer i; 0 <= i < n ==> s1[i] == s2[i];
 }
 */

/*@
 requires valid_dst: \valid(((unsigned char*)dest)+(0..n - 1));
 requires valid_src: \valid_read(((unsigned char*)src)+(0..n - 1));
 requires \separated(((unsigned char *)dest)+(0..n-1),((unsigned char *)src)+(0..n-1));
 assigns ((unsigned char*)dest)[0..n - 1] \from ((unsigned char*)src)[0..n-1];
 assigns \result \from dest;
 ensures memcmp_uchar((unsigned char*)dest,(unsigned char*)src,n) == 0;
 ensures \result == dest;
 */
unsigned char *memcpy_uchar(unsigned char *dest, unsigned char const *src, unsigned int n);
